<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="80px" label-position="right" size="small"
                 style="max-width: 500px;">
                <el-form-item prop="userId" label="用户ID">
                            <el-input-number type="number" v-model="formData.userId"></el-input-number>
                </el-form-item>
                <el-form-item prop="type" label="类型">
                    <el-select v-model="formData.type"
                               placeholder="请选择" value-key="item.label">
                        <el-option v-for="item in types" :key="item.value" :label="item.label" :value="item.value"></el-option>
                    </el-select>
                </el-form-item>
                <el-form-item prop="name" label="名称">
                            <el-input v-model="formData.name"></el-input>
                </el-form-item>
                <el-form-item prop="phone" label="联系电话">
                            <el-input v-model="formData.phone"></el-input>
                </el-form-item>
                <el-form-item prop="address" label="地址">
                            <el-input v-model="formData.address"></el-input>
                </el-form-item>
                <el-form-item prop="merName" label="商家名称">
                            <el-input v-model="formData.merName"></el-input>
                </el-form-item>
                <el-form-item prop="category" label="商家类型">
                            <el-input v-model="formData.category"></el-input>
                </el-form-item>
                <el-form-item prop="remark" label="合作内容">
                            <el-input v-model="formData.remark"></el-input>
                </el-form-item>
                <el-form-item prop="isPass" label="是否联系">
                            <el-switch v-model="formData.isPass"></el-switch>
                </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'CooperateApplyEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('cooperateApply/get/'+this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {
                },
                rules: {
                },
                types: [{label: "商家", value: "merchant"},
                    {label: "骑手", value: "rider"},
                    {label: "商务", value: "business"}],
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/cooperateApply/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/cooperateApply/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
